VIM(1)

NAVN
vim - Vi IMproved, en programmørs teksteditor

SYNOPSIS
vim [tilvalg] [fil ..]
vim [tilvalg] -
vim [tilvalg] -t tag
vim [tilvalg] -q [fejlfil]

ex
view
gvim gview evim eview
rvim rview rgvim rgview

BESKRIVELSE
Vim er en teksteditor som er opad kompatibel med Vi. Den kan bruges til at redigere alle slags ren tekst. Den er særlig nyttig til at redigere programmer.

Der er mange forbedringer over Vi: multiniveau fortryd, multivinduer og -buffere, syntaksfremhævning, redigering af kommandolinje, fuldførelse af filnavn, onlinehjælp, visuel markering, osv. Se ":help vi_diff.txt" for et overblik over forskellene mellem Vim og Vi.

Mens Vim kører, kan der indhentes massere af hjælp fra online-hjælpesystemet, med ":help"-kommandoen. Se ONLINEHJÆLP-sektionen nedenfor.

Oftest startes Vim for at redigere en enkelt fil med kommandoen

    vim fil

Mere generelt startes Vim med:

    vim [tilvalg] [filliste]

Hvis fillisten mangler, så startes editoren med en tom buffer. Ellers kan én af følgende fire måder bruges til at vælge en eller flere filer som skal redigeres.

fil ..
    En liste over filnavne. Den første bliver den nuværende fil og læses ind i bufferen. Markøren placeres på den første linje i bufferen. Du kan gå til de andre filer med ":next"-kommandoen. Skriv "--" foran fillisten, for at redigere en fil som begynder med en bindestreg.

-   Filen som skal redigeres læses fra stdin. Kommandoer læses fra stderr, hvilket skal være en tty.

-t {tag}
    Filen som skal redigeres og den indledende markørplacering afhænger af et "tag", en slags gå til-etiket. {tag} opslås i tags-filen, den tilknyttede fil bliver den nuværende fil og den tilknyttede kommando udføres. Det bruges mest til C-programmer, hvor {tag} kunne være et funktionsnavn. Virkningen er at filen som indeholder funktionen bliver den nuværende fil og markøren placeres i begyndelsen af funktionen. Se ":help tag-commands".

-q [fejlfil]
    Start i quickFix-tilstand. Filen [fejlfil] læses og den første fejl vises. Hvis [fejlfil] udelades, så indhentes filnavnet fra 'errorfile'-valgmuligheden (standard er "AztecC.Err" på Amiga, "errors.err" på andre systemer). Der kan hoppes til yderligere fejl med ":cn"-kommandoen. Se ":help quickfix".

Vim opfører sig anderledes, afhængig af navnet på kommandoen (eksekverbaren kan stadig være den samme fil).

vim Den "normale" måde, alt er standard.

ex  Start i Ex-tilstand. Gå til normal tilstand med ":vi"-kommandoen. Det kan også gøres med "-e"-argumentet.

view
    Start i skrivebeskyttet tilstand. Du vil være beskyttet mod at skrive filerne. Det kan også gøres med "-R"-argumentet.

gvim gview
    GUI-versionen. Starter et nyt vindue. Det kan også gøres med "-g"-argumentet.

evim eview
    GUI-versionen i easy-tilstand. Starter et nyt vindue. Det kan også gøres med "-y"-argumentet.

rvim rview rgvim rgview
    Som dem ovenfor, men med restriktioner. Det vil ikke være muligt at starte skalkommandoer, eller at suspendere Vim . Det kan også gøres med "-Z"-argumentet.

TILVALG
Tilvalgene kan gives i vilkårlig rækkefølge, før eller efter filnavnene. Tilvalg uden et argument kan kombineres efter en enkelt bindestreg.

+[nummer]
    Ved den første fil, placeres markøren på linje "nummer". Hvis "nummer" mangler, så placeres markøren på den sidste linje.

+/{sti}
    Ved den første fil, placeres markøren på linjen med den første forekomst af {sti}. Se ":help search-pattern" for tilgængelige søgemønstre.

+{kommando}

-c {kommando}
    {kommando} udføres efter den første fil er blevet læst. {kommando} fortolkes som en Ex-kommando. Hvis {kommando} indeholder mellemrum, så skal den omsluttes af dobbelte citationstegn (det afhænger af den skal der bruges). Eksempel: vim "+set si" main.c
    Bemærk: Du kan bruge op til 10 "+"- eller "-c"-kommandoer.

-S {fil}
    {fil} bliver sourced efter den første fil er blevet læst. Det svarer til -c "source {fil}". {fil} må ikke begynde med '-'. Hvis {fil} udelades, så bruges "Session.vim" (virker kun når -S er det sidste argument).

--cmd {kommando}
    Ligesom at bruge "-c", men kommandoen udføres lige inden behandlingen af vimrc-filer. Du kan bruge op til 10 af disse kommandoer, uafhængigt af "-c"-kommandoer.

-A  Hvis Vim blev kompileret med understøttelse af ARABIC til redigering af filer som er orienteret højre mod venstre og arabisk tastaturlayout, så starter tilvalget Vim i arabisk tilstand, dvs. 'arabic' sættes. Ellers gives en fejlmeddelelse og Vim afbrydes.

-b  Binær tilstand. Der sættes nogle få valgmuligheder som gør det muligt at redigere en binær eller eksekverbar fil.

-C  Kompatibel. Sæt 'compatible'-valgmuligheden. Det får Vim til at opføre sig mest som Vi, selvom der findes en .vimrc-fil.

-d  Start i diff-tilstand. Der skal være to, tre eller fire filnavneargumenter. Vim åbner alle filerne og viser forskellene mellem dem. Virker ligesom vimdiff(1).

-d {enhed}
    Åbn {enhed} til brug som en terminal. Kun på Amiga. Eksempel: "-d con:20/30/600/150".

-D  Fejlretning. Gå til fejlretningstilstand når den første kommando udføres fra et script.

-e  Start Vim i Ex-tilstand, ligesom hvis "ex"-eksekverbaren blev kaldt.

-E  Start Vim i forbedret Ex-tilstand, ligesom hvis "exim"-eksekverbaren blev kaldt.

-f  Forgrund. I GUI-versionen, vil Vim ikke fork'e og frigøre fra skallen som den blev startet i. På Amiga, genstartes Vim ikke for at åbne et nyt vindue. Tilvalget bør bruges når Vim udføres af et program der venter på at redigeringssession bliver færdig (f.eks. mail). På Amiga virker ":sh"- og ":!"-kommandoerne ikke.

--nofork
    Forgrund. I GUI-versionen, vil Vim ikke fork'e og frigøre fra skallen som den blev startet i.

-F  Hvis Vim blev kompileret med understøttelse af FKMAP til redigering af filer som er orienteret højre mod venstre og persisk tastaturlayout, så starter tilvalget Vim i persisk tilstand, dvs. 'fkmap' og 'rightleft' sættes. Ellers gives en fejlmeddelelse og Vim afbrydes.

-g  Hvis Vim blev kompileret med understøttelse af GUI, så aktiveres GUI'en af denne valgmulighed. Hvis understøttelse af GUI ikke blev kompileret ind, så gives en fejlmeddelelse og Vim afbrydes.

-h  Giv lidt hjælp om kommandolinjeargumenterne og tilvalgene. Herefter afsluttes Vim .

-H  Hvis Vim blev kompileret med understøttelse af RIGHTLEFT til redigering af filer som er orienteret højre mod venstre og hebraisk tastaturlayout, så starter tilvalget Vim i hebraisk tilstand, dvs. 'hkmap' og 'rightleft' sættes. Ellers gives en fejlmeddelelse og Vim afbrydes.

-i {viminfo}
    Når brug af viminfo-filen er aktiveret, så sætter tilvalget det filnavn som skal bruges, i stedet for standarden "~/.viminfo". Det kan også bruges til at springe brugen af .viminfo-filen over, ved at give navnet "NONE".

-L  Samme som -r.

-l  Lisp-tilstand. Sætter 'lisp'- og 'showmatch'-valgmulighederne til.

-m  Ændring af filer er deaktiveret. Nulstiller 'write'-valgmuligheden. Du kan stadig ændre bufferen, men det er ikke muligt at skrive en fil.

-M  Ændringer tillades ikke. 'modifiable'- og 'write'-valgmulighederne fjernes, så ændringer ikke er tilladt og filer ikke kan skrives. Bemærk at valgmulighederne kan sættes for at gøre det muligt at foretage ændringer.

-N  No-compatible-tilstand. Nulstil 'compatible'-valgmuligheden. Det får Vim til at opføre sig en smule bedre, men mindre Vi-kompatibel, selvom der ikke findes en .vimrc-fil.

-n  Der bruges ingen swap-fil. Det er umuligt at gendanne efter programmet er holdt op med at virke. God hvis du vil redigere en fil på et meget langsomt medie (f.eks. floppy). Kan også gøres med ":set uc=0". Kan fortrydes med ":set uc=200".

-nb Bliv en editor-server til NetBeans. Se dokumentationen for detaljer.

-o[N]
    Åbn N vinduer stablet. Når N udelades, så åbnes ét vindue pr. fil.

-O[N]
    Åbn N vinduer side om side. Når N udelades, så åbnes ét vindue pr. fil.

-p[N]
    Åbn N fanebladssider. Når N udelades, så åbnes én fanebladsside pr. fil.

-R  Skrivebeskyttet tilstand. 'readonly'-valgmuligheden sættes. Du kan stadig redigere bufferen, men vil være forhindret i fejlagtigt at overskrive en fil. Hvis du vil overskrive en fil, så tilføj et udråbstegn til Ex-kommandoen, som i ":w!". -R-tilvalget indebærer også -n-tilvalget (se ovenfor). 'readonly'-valgmuligheden kan slås fra med ":set noro". Se ":help 'readonly'".

-r  Oplist swap-filer, med information om at bruge dem til gendannelse.

-r {fil}
    Gendannelsestilstand. Swap-filen bruges til at gendanne en redigeringssession som holdt op med at virke. Swap-filen er en fil med det samme filnavn som tekstfilen, med ".swp" tilføjet i slutningen. Se ":help recovery".

-s  Stille tilstand. Kun når der startes som "Ex" eller når "-e"-tilvalget blev givet inden "-s"-tilvalget.

-s {scriptind}
    Script-filen {scriptind} læses. Tegnene i filen fortolkes som havde du skrevet dem. Det samme kan gøres med kommandoen ":source! {scriptind}". Hvis slutningen af filen nås inden editoren afslutter, så læses yderligere tegn fra tastaturet.

-T {terminal}
    Fortæller Vim navnet på terminalen som du bruger. Kræves kun når den automatisk måde ikke virker. Skal være en terminal som kendes af Vim (indbygget) eller defineret i termcap- eller terminfo-filen.

-u {vimrc}
    Brug kommandoerne i {vimrc}-filen til initialiseringer. Alle de andre initialiseringer springes over. Brug den til at redigere en særlig slags filer. Den kan også bruges til at springe alle initialiseringer over, ved at give navnet "NONE". Se ":help initialization" i vim for flere detaljer.

-U {gvimrc}
    Brug kommandoerne i {gvimrc}-filen til GUI-initialiseringer. Alle de andre GUI-initialiseringer springes over. Den kan også bruges til at springe alle GUI-initialiseringer over, ved at give navnet "NONE". Se ":help gui-init" i vim for flere detaljer.

-V[N]
    Uddybende. Giv meddelelser om hvilke filer som er sourced og til læsning og skrivning af en viminfo-fil. Det valgfrie nummer N er værdien af 'verbose'. Standard er 10.

-v  Start Vim i Vi-tilstand, ligesom eksekverbaren kaldet "vi". Det har kun virkning når eksekverbaren kaldes "ex".

-w {scriptud}
    Alle tegnene som du skrev optages i filen {scriptud}, indtil du afslutter Vim . Det er nyttigt hvis du vil oprette en script-fil som skal bruges med "vim -s" eller ":source!". Hvis {scriptud}-filen findes, så tilføjes tegnene til slutningen.

-W {scriptud}
    Ligesom -w, men en eksisterende fil overskrives.

-x  Brug kryptering når der skrives filer. Spørger efter en krypteringsnøgle.

-X  Opret ikke forbindelse til X-serveren. Afkorter opstartstiden i en terminal, men vinduets titel og udklipsholder bruges ikke.

-y  Start Vim i easy-tilstand, ligesom hvis "evim"- eller "eview"-eksekverbarene blev kaldt. Får Vim til at opføre sig som en klik og skriv-editor.

-Z  Restriktiv tilstand. Virker ligesom eksekverbaren som begynder med "r".

--  Betegner slutningen af tilvalgene. Argumenter efter dette håndteres som et filnavn. Det kan bruges til at redigere et filnavn som begynder med et '-'.

--echo-wid
    Kun GTK GUI: Ekko vinduets id på stdout.

--help
    Giv en hjælpemeddelelse og afslut, ligesom "-h".

--literal
    Tag filnavnets argumenter bogstaveligt, udvid ikke jokertegn. Det har ingen virkning i Unix hvor skallen udvidder jokertegn.

--noplugin
    Spring indlæsning af plugins over. Indebæres af -u NONE.

--remote
    Opret forbindelse til en Vim-server og få den til at redigere filerne som gives i resten af argumenterne. Hvis der ikke findes nogen server, så gives der en advarsel og filerne redigeres i den nuværende Vim.

--remote-expr {udtryk}
    Opret forbindelse til en Vim-server, evaluer {udtryk} i den og udskriv resultatet på stdout.

--remote-send {nøgler}
    Opret forbindelse til en Vim-server and send {nøgler} til den.

--remote-silent
    Som --remote, men uden advarslen når der ikke findes nogen server.

--remote-wait
    Som --remote, men Vim afslutter ikke før filerne er blevet redigeret.

--remote-wait-silent
    Som --remote-wait, men uden advarslen når der ikke findes nogen server.

--serverlist
    Oplist navnene på alle Vim-servere som der kan findes.

--servername {navn}
    Brug servernavnet {navn}. Bruges til den nuværende Vim, medmindre det bruges med et --remote-argument, så er det navnet på serveren som der skal oprettes forbindelse til.

--socketid {id}
    Kun GTK GUI: Brug GtkPlug-mekanismen til at køre gvim i et andet vindue.

--version
    Udskriv versionsinformation og afslut.

ONLINEHJÆLP
Skriv ":help" i Vim for at begynde. Skriv ":help emne" for at få hjælp til et bestemt emne. F.eks.: ":help ZZ" for at få hjælpe til "ZZ"-kommandoen. Brug <Tab> og CTRL-D for at fuldføre emner (":help cmdline-completion"). Tags findes til at hoppe fra et sted til et andet (en slags hypertekst-links, se ":help"). Alle dokumentationsfiler kan vises på denne måde, f.eks. ":help syntax.txt".

FILER

/opt/local/share/vim/vim92/doc/*.txt
    Vim -dokumentationsfilerne. Brug ":help doc-file-list" for at få den fulde liste.

/opt/local/share/vim/vim92/doc/tags
    Tags-filen som bruges til at finde information i dokumentationsfilerne.

/opt/local/share/vim/vim92/syntax/syntax.vim
    Systembrede syntaksinitialiseringer.

/opt/local/share/vim/vim92/syntax/*.vim
    Syntaksfiler til diverse sprog.

/opt/local/share/vim/vimrc
    Systembrede Vim -initialiseringer.

~/.vimrc
    Dine personlige Vim -initialiseringer.

/opt/local/share/vim/gvimrc
    Systembrede gvim-initialiseringer.

~/.gvimrc
    Dine personlige gvim-initialiseringer.

/opt/local/share/vim/vim92/optwin.vim
    Script som bruges til ":options"-kommandoen, en god måde til at vise og sætte valgmuligheder.

/opt/local/share/vim/vim92/menu.vim
    Systembrede menu-initialiseringer til gvim.

/opt/local/share/vim/vim92/bugreport.vim
    Script til at generere en fejlrapport. Se ":help bugs".

/opt/local/share/vim/vim92/filetype.vim
    Script til at registrere filtypen ud fra navnet. Se ":help 'filetype'".

/opt/local/share/vim/vim92/scripts.vim
    Script til at registrere filtypen ud fra indholdet. Se ":help 'filetype'".

/opt/local/share/vim/vim92/print/*.ps
    Filer som bruges til PostScript-udskrivning.

Læs VIM-hjemmesiden for seneste info:
<URL:http://www.vim.org/>

SE OGSÅ
vimtutor(1)

FORFATTER
Det meste af Vim blev lavet af Bram Moolenaar, med en masse hjælp fra andre. Se ":help credits" i Vim .
Vim er baseret på Stevie, arbejdet på af: Tim Thompson, Tony Andrews og G.R. (Fred) Walter. Selvom der næsten ikke er noget af den originale kode tilbage.

FEJL
Formodentligt. Se ":help todo" for en liste over kendte problemer.

Bemærk at flere ting som af nogle kan anses som værende fejl, faktisk er pga. en for nær reproduktion af Vi's opførsel. Og hvis du tænker at andre ting er fejl "fordi Vi gør det anderledes", så kig nærmere på vi_diff.txt-filen (eller skriv :help vi_diff.txt i Vim). Se også 'compatible'- og 'cpoptions'-valgmulighederne.